from os import system
import re


class miRNAn(object):

    def u_ends(self):
        data = open('human_uniq.fasta', 'r').readlines()

        x = 17
        result = open('nukl uniq na koncach.txt', 'w')
        while x < 28:
            start = "U"
            for i in range(4):
                begin = {}
                end = {}
                for j, line in enumerate(data):
                    if line.startswith('>'):
                        if len(data[j+1].strip()) == x:
                            temp = data[j+1].strip()
                            if temp[0] == start:
                                if begin.has_key(temp[0]):
                                    begin[temp[0]] += 1
                                else:
                                    begin[temp[0]] = 1
                                if end.has_key(temp[-1]):
                                    end[temp[-1]] += 1
                                else:
                                    end[temp[-1]] = 1

                
                k = begin.keys()
                v = begin.values()
                comment = "poczatek 5', dlugosc %s: \n"%x
                result.write(comment)
                for z in xrange(len(k)):
                    result.write(str(k[z]) + " : " + str(v[z]) + "\n")
            
                k = end.keys()
                v = end.values()
                comment = "koniec 3' poczatek %s: \n"%start
                result.write(comment)
                for z in xrange(len(k)):
                    result.write(str(k[z]) + " : " + str(v[z]) + "\n")
                if i == 0:
                    start = "A"
                if i == 1:
                    start = "C"
                if i == 2:
                    start = "G"

            x += 1
            result.write("\n")

    def aligment(self):
        lik = open('human.fasta','r').read().split('>')
        plik.remove('')
        results = open('wyniki_human.txt','w')
        found = 0

        for seq in plik:
            sekw = seq.split('\n')
            sekwencje_spr=open('sekwencje.txt','r').read().split('\n')
            # sekwencje_spr.remove('')
            for elem in sekwencje_spr:
                dlugosc = len(elem)
                print dlugosc
                cmd = '>%s\n%s\n>porownanie\n%s' %(sekw[0],sekw[1],elem)
                to_clust = open('to_clust.fasta','w')
                to_clust.write(cmd)
                to_clust.close()
                system('clustalw2 to_clust.fasta >> temp')
                align = open('to_clust.aln','r').read()
                stars = 0
                for el in align:
                    if el == '*':
                        stars += 1
                result = (stars + .00)/dlugosc
                if result > 0.8:
                    found += 1
                    results.write(align)
                    results.write('\n')
                    results.write('>>>>SCORE:%s/%s :%s\n' %(stars, dlugosc, result))
                    results.write('=======================================\n')

        #os.remove('to_clust.*')
        #os.remove('temp')
        results.close()

        print 'Zakonczono! Znaleziono:%s przypadkow' %found

    def cu_test(self):
        data = open("animals_uniq.fasta", "r").readlines()

        result = open("human_uniq_pir.txt","w")

        for i, line in enumerate(data):
            if line.startswith('>'):
                temp = data[i+1]
                l = len(temp.strip())
                if re.search('[C,U]'*l, temp):
                    result.write(line + data[i+1]) 
                    
        result.close()

    def harpin_modify(self):
        """
        Searches for hairpin motif UUCG, GAAA, GCAA, GAGA, GUGA, GGAA, CUUG,
        GUAAUA and GGACUUCGGUCC
        """

        data = open('human.fasta', 'r').readlines()

        name = []
        seq = []

        for i, line in enumerate(data):
            if line.startswith('>'):
                name.append(line)
                seq.append(data[i+1].strip())

        result = open('human_mf.txt', 'w')

        uucg = 0
        gaaa = 0
        gcaa = 0
        gaga = 0
        guga = 0
        ggaa = 0
        cuug = 0
        guaaua = 0
        ggacuucggucc = 0
        uucg_l = 0
        gaaa_l = 0
        gcaa_l = 0
        gaga_l = 0
        guga_l = 0
        ggaa_l = 0
        cuug_l = 0
        guaaua_l = 0
        ggacuucggucc_l = 0

        for i in xrange(len(seq)):
            check1 = 0
            check2 = 0
            check3 = 0
            check4 = 0
            check5 = 0
            check6 = 0
            check7 = 0
            check8 = 0
            check9 = 0
            for j in xrange(len(seq[i])):
                if j + 4 < len(seq[i]):
                    if seq[i][j] == "U" and seq[i][j+1] == "U" and seq[i][j+2] == "C" and seq[i][j+3] == "G":
                        uucg += 1
                        check1 = 1
                    if seq[i][j] == "G" and seq[i][j+1] == "A" and seq[i][j+2] == "A" and seq[i][j+3] == "A":
                        gaaa += 1
                        check2 = 1
                    if seq[i][j] == "G" and seq[i][j+1] == "C" and seq[i][j+2] == "A" and seq[i][j+3] == "A":
                        gcaa += 1
                        check3 = 1
                    if seq[i][j] == "G" and seq[i][j+1] == "A" and seq[i][j+2] == "G" and seq[i][j+3] == "A":
                        gaga += 1
                        check4 = 1
                    if seq[i][j] == "G" and seq[i][j+1] == "U" and seq[i][j+2] == "G" and seq[i][j+3] == "A":
                        guga += 1
                        check5 = 1
                    if seq[i][j] == "G" and seq[i][j+1] == "G" and seq[i][j+2] == "A" and seq[i][j+3] == "A":
                        ggaa += 1
                        check6 = 1
                    if seq[i][j] == "C" and seq[i][j+1] == "U" and seq[i][j+2] == "U" and seq[i][j+3] == "G":
                        cuug += 1
                        check7 = 1
                if j + 5 < len(seq[i]):
                    if seq[i][j] == "G" and seq[i][j+1] == "U" and seq[i][j+2] == "A" and seq[i][j+3] == "A" and seq[i][j+4] == "U" and seq[i][j+5] == "A":
                        guaaua += 1
                        check8 = 1
                if j + 11 < len(seq[i]):
                    if seq[i][j] == "G" and seq[i][j+1] == "G" and seq[i][j+2] == "A" and seq[i][j+3] == "C" and seq[i][j+4] == "U" \
                    and seq[i][j+5] == "U" and seq[i][j+6] == "C" and seq[i][j+7] == "G" and seq[i][j+8] == "G" and seq[i][j+9] == "U" \
                    and seq[i][j+10] == "C" and seq[i][j+11] == "C":
                        ggacuucggucc += 1
                        check9 = 1
            if check1 == 1:
                uucg_l += 1
            if check2 == 1:
                gaaa_l += 1
            if check3 == 1:
                gcaa_l += 1
            if check4 == 1:
                gaga_l += 1
            if check5 == 1:
                guga_l += 1
            if check6 == 1:
                ggaa_l += 1
            if check7 == 1:
                cuug_l += 1
            if check8 == 1:
                guaaua_l += 1
            if check9 == 1:
                ggacuucggucc_l += 1

        result.write("motif" + "\t" + "motif_number" + "\t" + "sequence_number" + "\n")
        result.write("uucg" + "\t" + str(uucg) + "\t" + str(uucg_l) + "\n")
        result.write("gaaa" + "\t" + str(gaaa) + "\t" + str(gaaa_l) + "\n")
        result.write("gcaa" + "\t" + str(gcaa) + "\t" + str(gcaa_l) + "\n")
        result.write("gaga" + "\t" + str(gaga) + "\t" + str(gaga_l) + "\n")
        result.write("guga" + "\t" + str(guga) + "\t" + str(guga_l) + "\n")
        result.write("ggaa" + "\t" + str(ggaa) + "\t" + str(ggaa_l) + "\n")
        result.write("cuug" + "\t" + str(cuug) + "\t" + str(cuug_l) + "\n")
        result.write("guaaua" + "\t" + str(guaaua) + "\t" + str(guaaua_l) + "\n")
        result.write("ggacuucggucc" + "\t" + str(ggacuucggucc) + "\t" + str(ggacuucggucc_l) + "\n")
        result.close()

    def motifs(self):
        plik=open('human_uniq.fasta').read().split('>')
        wyn=open('human_uniq_mot.txt','w')
        #plik=open('petle.fasta').read().split('>')
        #wyn=open('wyniki_petle_mot.fasta','a')

        dl=2
        while dl<7:#4
            d={}
            for elem in plik:
                if elem!='':
                    tmp=elem.split('\n')[1]
                    i=0
                    while i<len(tmp)-dl:
                        motif=''
                        sx=0
                        while sx<(dl):
                            motif=motif+tmp[i+sx]
                            sx+=1
                        try:
                            d[motif]+=1
                        except:
                            d[motif]=1
                        i+=1
            val=d.values()
            kys=d.keys()
            srt=[]
            for elem in kys:
                tmp=[d[elem],elem]
                srt.append(tmp)
            srt.sort()
            srt.reverse()
            suma=0
            for elem in val:
                suma+=elem
            for elem in srt:
                wyn.write(elem[1]+':%s(%s)\n' %(elem[0],round((((elem[0]+.00)/suma)*100),2)))
            cmd='SUMA:%s\n-------------------------------------------\n'%suma
            wyn.write(cmd)
            dl+=1

    def neuro_motifs(self):
        """Looks for neurodegenerative motifs, CGG, CAG, GCC, GAA, CUG must be at least 3 repeats in row"""

        data = open("human_uniq.fasta", "r").readlines()

        motif = {'CGG':0, 'CAG':0, 'GCC':0, 'GAA':0, 'CUG':0, 'CAA':0, 'UUG':0, 'GCG':0, 'CGC':0, 'GAC':0, 'GUC':0, 'UUC':0, 'CCG':0, 'CCUG':0, 'CAGG':0, 'UGGAA':0, 'UUCCA':0, 'AAUCU':0, 'AGAUU':0, 'CCGCC':0, 'GGCGG':0}
        seq = {'CGG':[], 'CAG':[], 'GCC':[], 'GAA':[], 'CUG':[], 'CAA':[], 'UUG':[], 'GCG':[], 'CGC':[], 'GAC':[], 'GUC':[], 'UUC':[], 'CCG':[], 'CCUG':[], 'CAGG':[], 'UGGAA':[], 'UUCCA':[], 'AAUCU':[], 'AGAUU':[], 'CCGCC':[], 'GGCGG':[]}
        times = 3

        for i, line in enumerate(data):
            if line.startswith('>'):
                temp = data[i+1].strip()
                if re.search('CGG'*times, temp):
                    motif['CGG'] += 1
                    seq['CGG'].append(line.strip())
                    seq['CGG'].append(temp)
                if re.search('CAG'*times, temp):
                    motif['CAG'] += 1
                    seq['CAG'].append(line.strip())
                    seq['CAG'].append(temp)
                if re.search('GCC'*3, temp):
                    motif['GCC'] += 1
                    seq['GCC'].append(line.strip())
                    seq['GCC'].append(temp)
                if re.search('GAA'*times, temp):
                    motif['GAA'] += 1
                    seq['GAA'].append(line.strip())
                    seq['GAA'].append(temp)
                if re.search('CUG'*times, temp):
                    motif['CUG'] += 1
                    seq['CUG'].append(line.strip())
                    seq['CUG'].append(temp)
                if re.search('CAA'*times, temp):
                    motif['CAA'] += 1
                    seq['CAA'].append(line.strip())
                    seq['CAA'].append(temp)
                if re.search('UUG'*times, temp):
                    motif['UUG'] += 1
                    seq['UUG'].append(line.strip())
                    seq['UUG'].append(temp)
                if re.search('GCG'*times, temp):
                    motif['GCG'] += 1
                    seq['GCG'].append(line.strip())
                    seq['GCG'].append(temp)
                if re.search('CGC'*times, temp):
                    motif['CGC'] += 1
                    seq['CGC'].append(line.strip())
                    seq['CGC'].append(temp)
                if re.search('GAC'*times, temp):
                    motif['GAC'] += 1
                    seq['GAC'].append(line.strip())
                    seq['GAC'].append(temp)
                if re.search('GUC'*times, temp):
                    motif['GUC'] += 1
                    seq['GUC'].append(line.strip())
                    seq['GUC'].append(temp)
                if re.search('UUC'*times, temp):
                    motif['UUC'] += 1
                    seq['UUC'].append(line.strip())
                    seq['UUC'].append(temp)
                if re.search('CCG'*times, temp):
                    motif['CCG'] += 1
                    seq['CCG'].append(line.strip())
                    seq['CCG'].append(temp)
                if re.search('CCUG'*times, temp):
                    motif['CCUG'] += 1
                    seq['CCUG'].append(line.strip())
                    seq['CCUG'].append(temp)
                if re.search('CAGG'*times, temp):
                    motif['CAGG'] += 1
                    seq['CAGG'].append(line.strip())
                    seq['CAGG'].append(temp)
                if re.search('UGGAA'*times, temp):
                    motif['UGGAA'] += 1
                    seq['UGGAA'].append(line.strip())
                    seq['UGGAA'].append(temp)
                if re.search('UUCCA'*times, temp):
                    motif['UUCCA'] += 1
                    seq['UUCCA'].append(line.strip())
                    seq['UUCCA'].append(temp)
                if re.search('AAUCU'*times, temp):
                    motif['AAUCU'] += 1
                    seq['AAUCU'].append(line.strip())
                    seq['AAUCU'].append(temp)
                if re.search('AGAUU'*times, temp):
                    motif['AGAUU'] += 1
                    seq['AGAUU'].append(line.strip())
                    seq['AGAUU'].append(temp)
                if re.search('CCGCC'*times, temp):
                    motif['CCGCC'] += 1
                    seq['CCGCC'].append(line.strip())
                    seq['CCGCC'].append(temp)
                if re.search('GGCGG'*times, temp):
                    motif['GGCGG'] += 1
                    seq['GGCGG'].append(line.strip())
                    seq['GGCGG'].append(temp)

        result = open('deg_motifs_human 3 time.txt', 'w')
        k = motif.keys()
        v = motif.values()
        s = seq.values()
        for x in xrange(len(k)):
            result.write(k[x] + "\t" + str(v[x]) + "\t" + str(s[x]) + "\n")
        result.close()

        # 4: CCUG, CAGG,
        # 5: UGGAA, UUCCA, AAUCU, AGAUU, CCGCC, GGCGG

    def nukl_length(self):
        Dane = open("human_seed.fasta", "r").readlines()
        Seq = []
        Nazwy_seq = []
        for linia in Dane:
            if not linia.startswith('>'):
                linia = linia.strip()
                Seq.append(linia)
            else:
                Nazwy_seq.append(linia)

        Zapis = open("human_seed_nukl.txt", "w")
        U = 0
        A = 0
        C = 0
        G = 0
        all = 0


        for i in xrange(len(Seq)):
            for litera in Seq[i]:
                if litera == 'U':
                    U += 1
                    all += 1
                if litera == 'A':
                    A += 1
                    all += 1
                if litera == 'C':
                    C += 1
                    all += 1
                if litera == 'G':
                    G += 1
                    all += 1


        Zapis.write("A: " + str(A) + '\n' + str(float(A)/all*100) + '%' + '\n' + "U: " + str(U) + '\n' + str(float(U)/all*100) + '%' + '\n' + "C: " + str(C) + '\n' + str(float(C)/all*100) + '%' + '\n' + "G: " + str(G) + '\n' + str(float(G)/all*100) + '%')
        Zapis.close()


    def qduplex(self):
        """
        Qadroduplex checking.
        """

        data = open('human_liniowe.fasta', 'r').readlines()

        name = []
        seq = []

        for i, line in enumerate(data):
            if line.startswith('>'):
                name.append(line)
                seq.append(data[i+1].strip())

        result = open('human_liniowe_duplex_GGGG.fasta', 'w')

        # SEARCH INSPIRED FROM PUBLICATION
        #for i in xrange(len(seq)):
            #gcheck = 0
            #for j in xrange(len(seq[i])):
                #if j+2 < len(seq[i]):
                    #if seq[i][j] == 'G' and seq[i][j+1] == 'G' and seq[i][j+2] == 'G':
                        #gcheck += 1
            #if gcheck > 2:
                #temp = seq[i].split('GGG')
                #if len(temp) > 2:
                    #ch = 0
                    #for fragment in temp:
                        #if len(fragment) < 7 and len(fragment) > 1:
                            #ch = 1
                        #else:
                            #ch = 0
                            #break
                    #if ch > 0:
                        #result.write(name[i])
                        #result.write(seq[i])
                        #result.write('\n')

        for i in xrange(len(seq)):
            for j in xrange(len(seq[i])):
                if j + 5 < len(seq[i]):
                    # if seq[i][j] == "U" and seq[i][j+1] == "G" and seq[i][j+2] == "G" and seq[i][j+3] == "G" and seq[i][j+4] == "G" and seq[i][j+5] == "U":
                    # if seq[i][j] == "U" and seq[i][j+1] == "G" and seq[i][j+2] == "G" and seq[i][j+3] == "G" and seq[i][j+4] == "U":
                    if seq[i][j] == "G" and seq[i][j+1] == "G" and seq[i][j+2] == "G" and seq[i][j+3] == "G":
                        result.write(name[i])
                        result.write(seq[i])
                        result.write('\n')
        result.close()
